'FFSubmenu=Effekte
'FFName=Runde Ecken

'FFSkriptName=RundeEcken.vbs
'FFSkriptArchiv=RundeEcken.zip
'FFSkriptDirectory=\MeckiScript\RundEcken
'FFSkriptFiles=
'FFScriptProfile=FF_RundeEcken

'FFSkriptAuthor=Harald Maeckler
'FFVersion=2.90.0

' ********************************************************************
' RundeEcken.vbs (Skript fr FixFoto)
' Funktion:	Bilder mit runden Ecken versehen
'
' Copyright Harald Maeckler, Dsseldorf 2012 - 2016
'
' Version 3.05 vom 27.03.2016	- Skript-URL gem Forenberarbeitung gendert
'								- Forenwei auf "250 250 250" gendert
' Version 3.04 vom 07.05.2012	- fr Hindergrund und Rand je 3 Farben vordefinierbar
'								- bessere Anpassung des grten Radius in Abhngigkeit
'								  der Grennderung
'								- Kurzbeschreibung als PDF-Datei
' Version 3.03 vom 02.05.2012	- Beschnitt auch fr maskierte Ausgaben mglich
' Version 3.02 vom 29.04.2012	- wenn FF < 3.30.70 wird als Ergebniseinstellung nur
'								  'Anzeige auf der Arbeitsflche' zugelassen
' Version 3.01 vom 29.04.2012	- Makorrektur bei Randstrke grer 0
' Version 3.00 vom 25.04.2012	- Gre und Lage des sichtbaren Teils
'								  schrittweise vertikal und horizontal vernderbar
'								- Beschnitt fr Anzeige auf der Arbeitsflche optional whlbar
' Version 2.03 vom 07.03.2012	- nderung der Updatefunktion
'								- Greneinstellung hinzu
' Version 2.02 vom 06.03.2012	- Vorschaunderung bei '< FF-wei'
' Version 2.01 vom 05.03.2012	- Bugs entfernt
'								- Vorschau bei Farbnderungen
' Version 2.00 vom 04.03.2012	- Vorschau
'								- auswhlbare Ergebnisbehandlungen
'									- Anzeige auf Arbeitsflche
'									- bernahme in Zwischensp. mit transp. Hintergrund
'									- Speichern mit Maske als PNG-Datei mit Suffix _msk
'								- Updatefunktion verbessert
' Version 1.02 vom 13.09.2012	- Option "bern. in den Zwischensp." ab Vers. 3.30.70
' Version 1.01 vom 16.02.2012	- Elemente im Dialog weiter auseinander gerckt
'								- Kurzbeschreibung ergnzt um 'Skript lschen'
' Version 1.00 vom 14.02.2012	- Betaversion
' ********************************************************************

Option Explicit

const SkriptName = "RundeEcken.vbs"

'Skriptkonstanten
const ForenWeiss = "250 250 250"					'Hintergrundfarbe des FF-Forums im Internet
const MaxVkl = 600	'max. Verkleinerung in Promille	'kann in 50er Schritten gendert werden / grer = kleiner mglich
const MassKorrektur = true							'Bild wird vor Randerzeugung verkleinert um die Randstrke

'Updatekonstanten und Variable
const SkriptVersion = "3.05"
const SkriptURL = "http://www.ffsf.de/resources/runde-ecken.162/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde
const Pruefzeit = 6

'Objekte
Dim objFS,WshShell
Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

'Lschroutine
Dim SkriptKill,TempFile	 : SkriptKill = false
Dim Antwort,Abbruch

'Diverses
const ForReading = 1, ForWriting = 2
const RegSchluessel = "FF_RundeEcken"

const Bbutton = 20,Hbutton = 20

Dim msg,eck_Radius,h_Farbe,hF_ref,r_Staerke,r_Farbe,rF_ref
Dim bx,hx,bb,hb,B,H,HG,D,Vignette,Rmax,maxR_Eingabe,VkPmX,vkX,vkPmY,vkY,S
Dim VsPmX,VsPmY,vsX,vsY,leftE,rightE,topE,bottomE
Dim flag_Beschnitt,flag_Aktiv,flag_ClipBoard,flag_PNG,Show,pngImage
Dim Farbe_HF1,Farbe_HF2,Farbe_HF3,Farbe_RF1,Farbe_RF2,Farbe_RF3
Dim isOverlapped	'Fremdaufruf

Dim tempImage  : tempImage = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Temp.png"
Dim WartenBlau : WartenBlau = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "BitteWarten_Blau.png"
Dim WartenGelb : WartenGelb = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "BitteWarten_Gelb.png"
Dim WartenRot  : WartenRot = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "BitteWarten_Rot.png"
Dim Img_HF1	   : Img_HF1 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_HF1.png"
Dim Img_HF2	   : Img_HF2 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_HF2.png"
Dim Img_HF3	   : Img_HF3 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_HF3.png"
Dim Img_RF1	   : Img_RF1 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_RF1.png"
Dim Img_RF2	   : Img_RF2 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_RF2.png"
Dim Img_RF3	   : Img_RF3 = FF_GetScriptPath & "\MeckiScript\RundeEcken\" & "Img_RF3.png"

Dim NeuDurchlauf : NeuDurchlauf = false
Dim VkPmXalt,vkPmYalt,VsPmXalt,VsPmYalt

'------------------------------------------------------------------------
msg = 	"Radius" & vbNewLine & _
		"--------" & vbNewLine & _
		"Der Radius wird in Promille der lngsten Seite vorgegeben." & vbNewLine & _
		"Er wird bei zu groen Werten automatisch auf den halben Wert" & vbNewLine & _
		"der krzeren Seite begrenzt." & vbNewLine & _
		"Wird 1000  eingetragen, wird das grtmgliche Oval zur" & vbNewLine & _
		"Maskierung verwendet." & vbNewLine & vbNewLine & _
		"Randstrke" & vbNewLine & _
		"------------" & vbNewLine & _
		"Es kann mit einem Wert > 0 ein Rand in Promille der lngsten" & vbNewLine & _
		"Seite erzeugt werden." & vbNewLine & vbNewLine & _
		"Farben" & vbNewLine & _
		"--------" & vbNewLine & _
		"Die Farben sind beliebig whlbar. Drei Farben knnen jeweils" & vbNewLine & _
		"vordefiniert werden." & vbNewLine & vbNewLine & _
		"Um Farbnderungen in der Vorschau zu kontrollieren, muss" & vbNewLine & _ 
		"bei FixFoto-Versionen < 3.30.75 die Taste ""Vorschau"" " & vbNewLine & _ 
		"bettigt oder mit der linken Maustaste das Vorschaubild" & vbNewLine & _ 
		"angeklickt oder ein Zahlenwert verndert werden" & vbNewLine & vbNewLine & _
		"Gre und Lage" & vbNewLine & _
		"-----------------" & vbNewLine & _
		"Gre und Lage des sichtbaren Teils kann in bestimmten" & vbNewLine & _
		"Grenzen schrittweise verndert werden." & vbNewLine & vbNewLine & _
		"Skript lschen" & vbNewLine & _
		"---------------" & vbNewLine & _
		"Dazu muss die Tastenkombination ""Alt"" + ""D"" bettigt werden." & vbNewLine & vbNewLine & _
		"                                                                     Harald Maeckler"
'------------------------------------------------------------------------
call Main
'------------------------------------------------------------------------
Sub Main	'### Hauptprogramm
Dim Anzeige

on error resume next							'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	FF_GetScriptPath
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

if not Version_OK("2.90.0") then
	msgbox "Es ist mindestens FixFoto-Version 2.90 erforderlich!",vbCritical,"Abbruch"
	exit sub
end if

'wenn das mit Overlapped erstellte Bild bearbeitet werden soll
isOverlapped = FF_GetProfile(RegSchluessel,"isOverlapped")
if isOverlapped = "" then isOverlapped = 0
if isOverlapped = 1 then
	msgbox "Es wird das mit Overlapped erzeugte Kugelbild angeboten!",vbInformation,"Hinweis"
	FF_LoadImage FF_GetScriptPath & "\MeckiScript\Overlapped\Over.jpg"
end if
FF_WriteProfile RegSchluessel,"isOverlapped",0

if FF_GetImageWidth = 0 then
	msgbox "Kein Bild geladen!",vbCritical,"Abbruch"
	exit sub
end if

'** Start Dialog Runde Ecken **
FF_AddDialog "Runde Ecken",302,276
FF_AddControl "Runde Ecken","Lage","GROUP",220,6,76,76
FF_AddControl "Runde Ecken","Gre","GROUP",140,6,76,76
FF_AddControl "Runde Ecken","Einstellungen","GROUP",5,6,131,76
FF_AddControl "Runde Ecken","Radius","STATIC",8,15,25,9
FF_AddControl "Runde Ecken","<","BUTTON",38,15,10,10
FF_AddControl "Runde Ecken","<<","BUTTON",49,15,10,10
FF_AddControl "Runde Ecken","|","STATIC",75,15,10,10
FF_AddControl "Runde Ecken",">>","BUTTON",86,15,10,10
FF_AddControl "Runde Ecken",">","BUTTON",97,15,10,10
FF_AddControl "Runde Ecken","Hintergrund","STATIC",8,53,29,11
FF_AddControl "Runde Ecken","h_Farbe","COLOR",38,52,36,12
FF_AddControl "Runde Ecken","Randstrke","STATIC",8,29,28,10
FF_AddControl "Runde Ecken","|<","BUTTON",38,29,10,10
FF_AddControl "Runde Ecken","|<<","BUTTON",49,29,10,10
FF_AddControl "Runde Ecken","","STATIC",75,29,10,10
FF_AddControl "Runde Ecken","|>>","BUTTON",86,29,10,10
FF_AddControl "Runde Ecken","|>","BUTTON",97,29,10,10
FF_AddControl "Runde Ecken","Randfarbe","STATIC",8,67,28,11
FF_AddControl "Runde Ecken","r_Farbe","COLOR",38,66,36,12
FF_AddControl "Runde Ecken","Ergebnis","GROUP",19,107,76,110
FF_AddControl "Runde Ecken","flag_Aktiv","BOOL",25,136,8,8
FF_AddControl "Runde Ecken","Anzeige auf","STATIC",38,131,50,9
FF_AddControl "Runde Ecken","flag_ClipBoard","BOOL",25,159,8,8
FF_SetControlStyle "Runde Ecken","flag_ClipBoard",16384
FF_AddControl "Runde Ecken","bernahme in den","STATIC",38,151,50,9
FF_AddControl "Runde Ecken","flag_PNG","BOOL",25,191,8,8
FF_SetControlStyle "Runde Ecken","flag_PNG",16384
FF_AddControl "Runde Ecken","Speichern mit","STATIC",38,178,45,9
FF_AddControl "Runde Ecken","_msk (maskiert)","STATIC",38,202,45,9
FF_AddControl "Runde Ecken","Vorschau >","BUTTON",75,91,32,11
FF_AddControl "Runde Ecken","VS_Image","IMAGE",116,90,180,180
FF_AddControl "Runde Ecken","?","BUTTON",15,233,12,12
FF_AddControl "Runde Ecken","Update","BUTTON",66,233,33,12
FF_AddControl "Runde Ecken","Start","BUTTON",75,253,32,12
FF_AddControl "Runde Ecken","&delete","BUTTON",2,2,1,1
FF_AddControl "Runde Ecken","Oval","BUTTON",108,15,16,10
FF_AddControl "Runde Ecken","|","STATIC",62,15,12,10
FF_SetControlStyle "Runde Ecken","|",2
FF_AddControl "Runde Ecken","||","STATIC",62,29,12,10
FF_SetControlStyle "Runde Ecken","||",2
FF_AddControl "Runde Ecken","||<","BUTTON",146,39,10,10
FF_AddControl "Runde Ecken","||<<","BUTTON",157,39,10,10
FF_AddControl "Runde Ecken","||>>","BUTTON",189,39,10,10
FF_AddControl "Runde Ecken","||>","BUTTON",200,39,10,10
FF_AddControl "Runde Ecken","|||^","BUTTON",253,12,10,10
FF_AddControl "Runde Ecken","|||v","BUTTON",253,65,10,10
FF_AddControl "Runde Ecken","|||>","BUTTON",280,39,10,10
FF_AddControl "Runde Ecken","|||<","BUTTON",226,39,10,10
FF_AddControl "Runde Ecken","|Null","BUTTON",250,39,16,10
FF_AddControl "Runde Ecken","flag_Beschnitt","BOOL",49,117,8,8
FF_AddControl "Runde Ecken","mit Beschnitt","STATIC",59,116,32,10
FF_AddControl "Runde Ecken","Max","BUTTON",170,39,16,10
FF_AddControl "Runde Ecken","Null","BUTTON",108,29,16,10
FF_AddControl "Runde Ecken","|^","BUTTON",173,12,10,10
FF_AddControl "Runde Ecken","||^","BUTTON",173,25,10,10
FF_AddControl "Runde Ecken","|v","BUTTON",173,65,10,10
FF_AddControl "Runde Ecken","||v","BUTTON",173,53,10,10
FF_AddControl "Runde Ecken","Abbrechen","BUTTON",5,253,32,12
FF_AddControl "Runde Ecken","||||^","BUTTON",253,25,10,10
FF_AddControl "Runde Ecken","||||v","BUTTON",253,53,10,10
FF_AddControl "Runde Ecken","|||>>","BUTTON",269,39,10,10
FF_AddControl "Runde Ecken","|||<<","BUTTON",237,39,10,10
FF_AddControl "Runde Ecken","vertikal","STATIC",143,16,26,10
FF_SetControlStyle "Runde Ecken","vertikal",1
FF_AddControl "Runde Ecken","|vertikal","STATIC",223,16,26,10
FF_SetControlStyle "Runde Ecken","|vertikal",1
FF_AddControl "Runde Ecken","horizontal","STATIC",188,54,26,10
FF_SetControlStyle "Runde Ecken","horizontal",1
FF_AddControl "Runde Ecken","|horizontal","STATIC",266,54,26,10
FF_SetControlStyle "Runde Ecken","|horizontal",1
FF_AddControl "Runde Ecken","|||","STATIC",143,25,26,10
FF_SetControlStyle "Runde Ecken","|||",1
FF_AddControl "Runde Ecken","||||","STATIC",188,63,26,10
FF_SetControlStyle "Runde Ecken","||||",1
FF_AddControl "Runde Ecken","|||||","STATIC",223,25,26,10
FF_SetControlStyle "Runde Ecken","|||||",1
FF_AddControl "Runde Ecken","||||||","STATIC",266,63,26,10
FF_SetControlStyle "Runde Ecken","||||||",1
FF_AddControl "Runde Ecken","|||||||","STATIC",36,235,24,10
FF_SetControlStyle "Runde Ecken","|||||||",1
FF_AddControl "Runde Ecken","der Arbeitsflche","STATIC",38,139,50,9
FF_AddControl "Runde Ecken","Zwischenspeicher","STATIC",38,159,50,9
FF_AddControl "Runde Ecken","mit Transparenz","STATIC",38,167,50,9
FF_AddControl "Runde Ecken","Maske als PNG-","STATIC",38,186,45,9
FF_AddControl "Runde Ecken","Datei mit Suffix","STATIC",38,194,45,9
FF_AddControl "Runde Ecken","V_Fortschritt","PROGRESS",15,226,84,4
FF_AddControl "Runde Ecken","G_Image","IMAGE",189,14,21,21
FF_AddControl "Runde Ecken","K_Image","IMAGE",146,54,21,21
FF_AddControl "Runde Ecken","RO_Image","IMAGE",269,14,21,21
FF_AddControl "Runde Ecken","LU_Image","IMAGE",226,54,21,21
FF_AddControl "Runde Ecken","vordefiniert","STATIC",82,42,33,9
FF_SetControlStyle "Runde Ecken","vordefiniert",1
FF_AddControl "Runde Ecken","HF1","IMAGE",78,52,12,12
FF_AddControl "Runde Ecken","HF2","IMAGE",92,52,12,12
FF_AddControl "Runde Ecken","HF3","IMAGE",106,52,12,12
FF_AddControl "Runde Ecken","RF1","IMAGE",78,66,12,12
FF_AddControl "Runde Ecken","RF2","IMAGE",92,66,12,12
FF_AddControl "Runde Ecken","RF3","IMAGE",106,66,12,12
FF_AddControl "Runde Ecken","Def","BUTTON",123,44,9,34
'** End Dialog Runde Ecken **

FF_PushImage
call RegistryLesen
FF_PopImage

if not Version_OK("3.30.70") then
	FF_SetControl "Runde Ecken","flag_ClipBoard",0
	FF_SetControl "Runde Ecken","flag_PNG",0
end if

FF_SetControlImage "Runde Ecken","Def",FF_GetScriptPath & "\MeckiScript\RundeEcken\Definition.png"

FF_SetControlImage "Runde Ecken","|^",FF_GetScriptPath & "\MeckiScript\RundeEcken\Y+.png"
FF_SetControlImage "Runde Ecken","|v",FF_GetScriptPath & "\MeckiScript\RundeEcken\Y-.png"
FF_SetControlImage "Runde Ecken","||^",FF_GetScriptPath & "\MeckiScript\RundeEcken\YY+.png"
FF_SetControlImage "Runde Ecken","||v",FF_GetScriptPath & "\MeckiScript\RundeEcken\YY-.png"

FF_SetControlImage "Runde Ecken","|||^",FF_GetScriptPath & "\MeckiScript\RundeEcken\Y+.png"
FF_SetControlImage "Runde Ecken","|||v",FF_GetScriptPath & "\MeckiScript\RundeEcken\Y-.png"
FF_SetControlImage "Runde Ecken","||||^",FF_GetScriptPath & "\MeckiScript\RundeEcken\YY+.png"
FF_SetControlImage "Runde Ecken","||||v",FF_GetScriptPath & "\MeckiScript\RundeEcken\YY-.png"

FF_SetControl "Runde Ecken","G_Image",FF_GetScriptPath & "\MeckiScript\RundeEcken\gross.bmp"
FF_SetControl "Runde Ecken","K_Image",FF_GetScriptPath & "\MeckiScript\RundeEcken\klein.bmp"
FF_SetControl "Runde Ecken","LU_Image",FF_GetScriptPath & "\MeckiScript\RundeEcken\vs_lu.bmp"
FF_SetControl "Runde Ecken","RO_Image",FF_GetScriptPath & "\MeckiScript\RundeEcken\vs_ro.bmp"

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Runde Ecken","Def", "" &_
						 "Farben vordefinieren"
	FF_SetControlTooltip "Runde Ecken","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & _
						 "vorausgesetzt es ist ein PDF-Reader installiert." & vbNewLine & _
						 "Anderenfalls wird eine gekrzte Textversion angezeigt."
	FF_SetControlTooltip "Runde Ecken","Update", "" &_
						 "Prfung ob eine neue Version vorliegt"
	FF_SetControlTooltip "Runde Ecken","Start", "" &_
						 "Ausgabe gem Ergebniseinstellungen"
	FF_SetControlTooltip "Runde Ecken","Abbrechen", "" &_
						 "vorzeitige Beendigung des Skript"
	FF_SetControlTooltip "Runde Ecken","Vorschau >", "" &_
						 "Vorschau auf zu erwartende Ausgabe"
end if

'Maximalen Eingabewert fr Radius berechnen
bx = FF_GetImageWidth *1
hx = FF_GetImageHeight *1
if bx > hx then
	maxR_Eingabe = int(50 * hx / bx) * 10 +10
else
	maxR_Eingabe = int(50 * bx / hx) * 10 +10
end if
if eck_Radius > maxR_Eingabe and eck_Radius <> 1000 then
	eck_Radius = maxR_Eingabe
end if

if not Version_OK("3.30.70") then
	FF_EnableControl "Runde Ecken","flag_ClipBoard",false
	FF_EnableControl "Runde Ecken","flag_PNG",false
	FF_SetControl "Runde Ecken","flag_Aktiv",1
	msgbox "Da die FixFoto-Version kleiner ist als 3.30.70" & vbNewLine & _
		   "ist fr die Ergebniseinstellung nur" & vbNewLine & _
		   "'Anzeige auf der Arbeitsflche' zugelassen.",vbInformation,"Hinweis"
end if

call Vorschau

FF_SetDialogTimer "Runde Ecken",100
FF_ActivateControl "Runde Ecken","&delete"

do
	Abbruch = false
	
	Select Case FF_ShowDialog ("Runde Ecken")
	Case "TIMER"
		FF_SetControl "Runde Ecken","|||||||","V " & SkriptVersion
	
		FF_SetControl "Runde Ecken","|",eck_Radius
		FF_SetControl "Runde Ecken","||",r_Staerke

		FF_SetControl "Runde Ecken","|||"	,(1000 - vkPmY)/10 & "%"
		FF_SetControl "Runde Ecken","||||"	,(1000 - vkPmX)/10 & "%"
		FF_SetControl "Runde Ecken","|||||"	,VsPmY * -1 & ""
		FF_SetControl "Runde Ecken","||||||",VsPmX & ""

		FF_SetDialogTimer "Runde Ecken",0
	Case "&delete"
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "<"							'Radius
		if eck_Radius = 1000 then
			eck_Radius = maxR_Eingabe
		elseif eck_Radius > 10 then
			eck_Radius = eck_Radius - 10
		end if
		FF_SetControl "Runde Ecken","|",eck_Radius
		call Vorschau
	Case "<<"							'Radius
		if eck_Radius = 1000 then
			eck_Radius = maxR_Eingabe
		elseif eck_Radius > 50 then
			eck_Radius = eck_Radius - 50
		else
			eck_Radius = 10
		end if
		FF_SetControl "Runde Ecken","|",eck_Radius
		call Vorschau
	Case ">"							'Radius
		if eck_Radius <> 1000 then
		if eck_Radius <= (maxR_Eingabe - 10) then
			eck_Radius = eck_Radius + 10
		else
			eck_Radius = maxR_Eingabe
		end if
		end if
		FF_SetControl "Runde Ecken","|",eck_Radius
		call WerteAuslesen
		call Vorschau
	Case ">>"							'Radius
		if eck_Radius <> 1000 then
		if eck_Radius <= (maxR_Eingabe - 50) and eck_Radius <> 1000 then
			eck_Radius = eck_Radius + 50
		else
			eck_Radius = maxR_Eingabe
		end if
		end if
		FF_SetControl "Runde Ecken","|",eck_Radius
		call WerteAuslesen
		call Vorschau
	Case "Oval"							'Radius
		eck_Radius = 1000
		FF_SetControl "Runde Ecken","|",eck_Radius
		call Vorschau
	Case "HF1"
		FF_SetControl "Runde Ecken","h_Farbe",Farbe_HF1
		call Vorschau
	Case "HF2"
		FF_SetControl "Runde Ecken","h_Farbe",Farbe_HF2
		call Vorschau
	Case "HF3"
		FF_SetControl "Runde Ecken","h_Farbe",Farbe_HF3
		call Vorschau
	Case "RF1"
		FF_SetControl "Runde Ecken","r_Farbe",Farbe_RF1
		call Vorschau
	Case "RF2"
		FF_SetControl "Runde Ecken","r_Farbe",Farbe_RF2
		call Vorschau
	Case "RF3"
		FF_SetControl "Runde Ecken","r_Farbe",Farbe_RF3
		call Vorschau
	Case "< FF-wei"
		FF_SetControl "Runde Ecken","h_Farbe",ForenWeiss
		call Vorschau
	Case "Def"
		call Farbe_definieren
	Case "|<"							'Rand
		if r_Staerke > 0 then r_Staerke = r_Staerke - 1
		FF_SetControl "Runde Ecken","||",r_Staerke
		call Vorschau
	Case "|<<"							'Rand
		if r_Staerke > 5 then
			r_Staerke = r_Staerke - 5
		else
			r_Staerke = 0
		end if
		FF_SetControl "Runde Ecken","||",r_Staerke
		call Vorschau
	Case "|>"							'Rand
		r_Staerke = r_Staerke + 1
		FF_SetControl "Runde Ecken","||",r_Staerke
		call Vorschau
	Case "|>>"							'Rand
		r_Staerke = r_Staerke + 5
		FF_SetControl "Runde Ecken","||",r_Staerke
		call Vorschau
	Case "Null"							'Rand
		r_Staerke = 0
		FF_SetControl "Runde Ecken","||",r_Staerke
		call Vorschau
	Case "||>"							'Gre horizontal +
	if leftE > 0 and rightE > 0 then
		if VkPmX > 10 then
			VkPmX = VkPmX - 10
		else
			VkPmX = 0
		end if
		call Vorschau
	end if
	Case "||>>"							'Gre horizontal ++
	if leftE > 0 and rightE > 0 then
		if VkPmX > 50 then
			VkPmX = VkPmX - 50
		else
			VkPmX = 0
		end if
		call Vorschau
	end if
	Case "||<"							'Gre horizontal -
		if VkPmX <= (MaxVkl - 10) then
			VkPmX = VkPmX + 10
		else
			VkPmX = MaxVkl
		end if
		call Vorschau
	Case "||<<"							'Gre horizontal --
		if VkPmX <= (MaxVkl - 50) then
			VkPmX = VkPmX + 50
		else
			VkPmX = MaxVkl
		end if
		call Vorschau
	Case "Max"							'Gre Maximum (100%)
		VkPmX = 0 : VkPmY = 0
		VsPmX = 0 : VsPmY = 0
		call Vorschau
	Case "|^"							'Gre vertikal +
	if topE > 0 and bottomE > 0 then
		if vkPmY > 10 then
			vkPmY = vkPmY - 10
		else
			vkPmY = 0
		end if
		call Vorschau
	end if
	Case "||^"							'Gre vertikal ++
	if topE > 0 and bottomE > 0 then
		if vkPmY > 50 then
			vkPmY = vkPmY - 50
		else
			vkPmY = 0
		end if
		call Vorschau
	end if
	Case "|v"							'Gre vertikal -
		if vkPmY <= (MaxVkl - 10) then
			vkPmY = vkPmY + 10
		else
			vkPmY = MaxVkl
		end if
		call Vorschau
	Case "||v"							'Gre vertikal --
		if vkPmY <= (MaxVkl - 50) then
			vkPmY = vkPmY + 50
		else
			vkPmY = MaxVkl
		end if
		call Vorschau
	Case "|||<"							'Verschiebung horizontal -
		if (abs(VsPmX) < vkPmX \ 2 or VsPmX > 0) and leftE > 0 then VsPmX = VsPmX - 5
		call Vorschau
	Case "|||<<"						'Verschiebung horizontal - -
		if (abs(VsPmX) < vkPmX \ 2 or VsPmX > 0) and leftE > 0 then
			VsPmX = VsPmX - 25
		else
			VsPmX = - vkPmX \ 2
		end if
		call Vorschau
	Case "|||>"							'Verschiebung horizontal +
		if VsPmX < vkPmX \ 2 and rightE > 0 then VsPmX = VsPmX + 5
		call Vorschau
	Case "|||>>"						'Verschiebung horizontal ++
		if VsPmX < vkPmX \ 2  and rightE > 0 then
			VsPmX = VsPmX + 25
		else
			VsPmX = vkPmX \ 2
		end if
		call Vorschau
	Case "|Null"						'Verschiebung Null
		VsPmX = 0 : VsPmY = 0
		call Vorschau
	Case "|||^"							'Verschiebung vertikal +
		if (abs(VsPmY) < vkPmY \ 2 or VsPmY > 0) and topE > 0 then VsPmY = VsPmY - 5
		call Vorschau
	Case "||||^"						'Verschiebung vertikal ++
		if (abs(VsPmY) < vkPmY \ 2 or VsPmY > 0) and topE > 0  then	VsPmY = VsPmY - 25
		if abs(VsPmY) > vkPmY \ 2 then VsPmY = - vkPmY \ 2
		call Vorschau
	Case "|||v"							'Verschiebung vertikal -
		if (abs(VsPmY) < vkPmY \ 2 or VsPmY < 0) and bottomE > 0 then VsPmY = VsPmY + 5
		call Vorschau
	Case "||||v"						'Verschiebung vertikal - -
		if (abs(VsPmY) < vkPmY \ 2 or VsPmY < 0) and bottomE > 0 then VsPmY = VsPmY + 25
		if abs(VsPmY) > vkPmY \ 2 then VsPmY = vkPmY \ 2
		call Vorschau
	Case "flag_ClipBoard","flag_PNG"
		if not Version_OK("3.30.70") then
			FF_SetControl "Runde Ecken","flag_ClipBoard",0
			FF_SetControl "Runde Ecken","flag_PNG",0
			msgbox 	"Diese Option steht erst" & vbNewLine & _
					"ab FF-Version 3.30.70 zur Verfgung!",vbInformation,"Hinweis"
		end if
	Case "Vorschau >","VS_Image","h_Farbe","r_Farbe"
		call Vorschau
	Case "?"
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\RundeEcken\RundeEcken.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			msgbox msg,vbInformation,"Kurzbeschreibung ""Runde Ecken"""
			
		end if
		on error GoTo 0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "Start"
		call WerteAuslesen
		if flag_Aktiv = 0 and flag_Clipboard = 0 and flag_PNG = 0 then
			msgbox 	"Fr die Ergebnisauswertung muss mindestens" & vbNewLine & _
					"eine Aktivitt ausgewhlt werden!",vbInformation,"Hinweis"
		else
			FF_SetControl "Runde Ecken","VS_Image",WartenRot
			FF_RefreshDialog "Runde Ecken"
			Show = false
			FF_PushImage
			call Ecken
			if flag_PNG = 1 then
				msgbox 	"Das erzeugte Bild wurde als" & vbNewLine &_
						"  " & pngImage & vbNewLine & "abgespeichert!",vbInformation,"Hinweis"
			end if
			exit do
		end if
	Case "CANCEL","Abbrechen"
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Runde Ecken")
if SkriptKill then	'ggf. Skript komplett entfernen
	call KillSkript
end if

End sub
'------------------------------------------------------------------------
Sub Ecken
Dim R,RGB
const k = 2 'Korrektur

bb = FF_GetImageWidth
hb = FF_GetImageHeight

'Vorberechnungen
if bb > hb then

	if not NeuDurchlauf then S = bb * r_Staerke \ 1000
	if not NeuDurchlauf and Masskorrektur and S > 0 then	'Mafehler abfangen
		bb = bb - 2* S : hb = hb - 2* S
		FF_HQScale bb,hb,false
	end if

	vkX = bb * VkPmX \ 1000
	vkY = bb * vkPmY \ 1000
	
	vsX = bb * VsPmX \ 1000
	vsY = bb * VsPmY \ 1000
	
	if eck_Radius *1 >= 1000 then
		Vignette = true
	else
		Vignette = false
		R = (bb - vkX) * eck_Radius \ 1000
		if R > (hb - vkY) \ 2 then
			R = (hb - vkY) \ 2 +k
			Rmax = true
		else
			Rmax = false
		end if
	end if

else

	if not NeuDurchlauf then S = hb * r_Staerke \ 1000
	if not NeuDurchlauf and Masskorrektur and S > 0 then	'Mafehler abfangen
		bb = bb - 2* S : hb = hb - 2* S
		FF_HQScale bb,hb,false
	end if

	vkX = hb * VkPmX \ 1000
	vkY = hb * vkPmY \ 1000
	
	vsX = hb * VsPmX \ 1000
	vsY = hb * VsPmY \ 1000
	
	if eck_Radius *1 >= 1000 then
		Vignette = true
	else
		Vignette = false
		R = (hb - vky) * eck_Radius \ 1000
		if R > (bb - vkX) \ 2 then
			R = (bb - vkX) \ 2 +k
			Rmax = true
		else
			Rmax = false
		end if
	end if
	
end if

D = 2 * R

bb = bb - vkX
hb = hb - vkY

'maximalen Radius neu berechnen
if bb > hb then
	maxR_Eingabe = int(50 * hb / bb) * 10 +10
else
	maxR_Eingabe = int(50 * bb / hb) * 10 +10
end if


'Verschieberechnung
leftE = vkX \ 2 + vsX
if leftE < 0 then leftE = 0

rightE = vkX \ 2 - vsX
if rightE < 0 then rightE = 0

topE = vkY \ 2 + vsY
if topE < 0 then topE = 0

bottomE = vkY \ 2 - vsY
if bottomE < 0 then	bottomE = 0

'Maskenbildung
FF_PushImage
if S > 0 then HG = rF_ref else HG = hF_ref

call MaskenAddition

'Hintergrund auen wenn gerahmt wird (S > 0)
if S > 0 then
	HG = hF_ref
	RGB = split(r_Farbe," ")
	FF_ExtendCanvas S,S,S,S,RGB(0),RGB(1),RGB(2)
	bb = FF_GetImageWidth - vkX
	hb = FF_GetImageHeight - vkY
	FF_SwapImage
	call MaskenAddition
end if

'Ausgabe
if show then
	FF_SaveImage tempImage,0
else
	if (flag_Aktiv = 1) and (not NeuDurchlauf) then
		if flag_Beschnitt = 1 then FF_Crop leftE,topE,bb,hb
		FF_Reload
	end if
	
	if ((flag_ClipBoard = 1) or (flag_PNG = 1)) and (flag_Beschnitt = 1) then
		if not NeuDurchlauf then
			FF_PopImage
			FF_PopImage
			FF_Crop leftE + S,topE + S,bb - 2* S,hb - 2* S
			VkPmXalt = VkPmX : vkPmYalt = vkPmY : VsPmXalt = VsPmX : VsPmYalt = VsPmY
			VkPmX = 0 : vkPmY = 0 : VsPmX = 0 : VsPmY = 0
			NeuDurchlauf = true
			FF_PushImage
			call Ecken
			VkPmX = VkPmXalt : vkPmY = vkPmYalt : VsPmX = VsPmXalt : VsPmY = VsPmYalt
		else
			call Ausgabe
		end if
	end if
	
	if ((flag_ClipBoard = 1) or (flag_PNG = 1)) and (flag_Beschnitt = 0) then call Ausgabe

end if

End Sub
'------------------------------------------------------------------------
Sub Ausgabe
'fr Ablage im Zwischenspeicher und/oder abspeichern, jeweils mit Maske

	if (flag_ClipBoard = 1) then
'Msgbox "in die Zwischenablage" & vbNewLine & "Neudurchlauf = " & NeuDurchlauf
		FF_SetControl "Runde Ecken","VS_Image",WartenBlau
		FF_RefreshDialog "Runde Ecken"
		FF_Build32 ""
	end if
	
	if flag_PNG = 1 then
'Msgbox "Maske speichern" & vbNewLine & "Neudurchlauf = " & NeuDurchlauf
		FF_SetControl "Runde Ecken","VS_Image",WartenGelb
		FF_RefreshDialog "Runde Ecken"
		pngImage = FF_GetImageName(-1)
'Msgbox pngImage
		if len(pngImage) = 0 then
			pngImage = FF_GetImagePath & "\Neu_msk.png"
		else
			pngImage = left(pngImage,InStrRev(pngImage,".") -1) & "_msk.png"
		end if
		FF_Build32 pngImage
	end if

'Msgbox "B = " & FF_GetImageWidth & " / leftE = " & leftE & " / bb = " & bb & vbNewLine & "H = " & FF_GetImageHeight & " / topE = " & topE  & " / hb = " & hb

End sub
'------------------------------------------------------------------------
Sub MaskenAddition
Dim n
Dim bm,hm,bn,hn
const k = 1 'Korrektur

'Maske erstellen
if Vignette then
	FF_NewImage bb,hb,0
	FF_Chord k,k,bb -2* k,hb -2* k,0,0,0,0,16777215,0
else
	B = bb + 10 : H = hb + 10
	FF_NewImage B,H,0
	FF_Line 0,H \ 2,B,H \ 2,16777215,H - D - 2* k
	FF_Line B \ 2,0,B \ 2,H,16777215,B - D - 2* k
	FF_Crop 5,5,bb,hb
	for n = 1 to 4
		if Rmax then 
			FF_Chord 2* k,2* k,D -4* k,D -4* k,0,0,0,0,16777215,0	'optimal fr R = H /2
		else
			FF_Chord k \ 2,k \ 2,D -4* k,D -4* k,0,0,0,0,16777215,0	'optimal fr < R
		end if 
		FF_Rotate 90,0,0
	next
end if

FF_ExtendCanvas leftE,rightE,topE,bottomE,0,0,0
FF_HQScale bb + vkX,hb + vkY,false	'sicherheitshalber
FF_Putmask

'Hintergrundbild erstellen
FF_NewImage bb + vkX,hb + vkY,HG
FF_rgbgamma 0,1,0.5,0,0, 0,1,0.5,0,0,  0,1,0.5,0,0	'Tonwertkorrektur + Begrenzung

'Addieren
call FF_Blend(1,13,255)

End sub
'------------------------------------------------------------------------
Sub Farbe_definieren

'** Start Dialog Farbdefinition **
FF_AddDialog "Farbdefinition",127,71
FF_AddControl "Farbdefinition","Hintergrund","STATIC",5,21,33,11
FF_AddControl "Farbdefinition","v   FF-forenwei","BUTTON",39,7,48,10
FF_AddControl "Farbdefinition","EHF1","COLOR",39,21,22,10
FF_AddControl "Farbdefinition","EHF2","COLOR",67,21,22,10
FF_AddControl "Farbdefinition","EHF3","COLOR",95,21,22,10
FF_AddControl "Farbdefinition","Randfarbe","STATIC",5,34,33,11
FF_AddControl "Farbdefinition","ERF1","COLOR",39,35,22,10
FF_AddControl "Farbdefinition","ERF2","COLOR",67,35,22,10
FF_AddControl "Farbdefinition","ERF3","COLOR",95,35,22,10
FF_AddControl "Farbdefinition","Abbrechen","BUTTON",13,53,33,11
FF_AddControl "Farbdefinition","bernehmen","BUTTON",80,53,35,11
'** End Dialog Farbdefinition **

FF_SetControl "Farbdefinition","EHF1",Farbe_HF1
FF_SetControl "Farbdefinition","EHF2",Farbe_HF2
FF_SetControl "Farbdefinition","EHF3",Farbe_HF3
FF_SetControl "Farbdefinition","ERF1",Farbe_RF1
FF_SetControl "Farbdefinition","ERF2",Farbe_RF2
FF_SetControl "Farbdefinition","ERF3",Farbe_RF3

do
	Select Case FF_ShowDialog ("Farbdefinition")
		Case "v   FF-forenwei"
			FF_SetControl "Farbdefinition","EHF1",ForenWeiss
		Case "bernehmen"
			FF_PushImage
			
			Farbe_HF1 = FF_GetControl("Farbdefinition","EHF1")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF1)
			FF_SaveImage Img_HF1,0
			FF_SetControl "Runde Ecken","HF1",Img_HF1
			
			Farbe_HF2 = FF_GetControl("Farbdefinition","EHF2")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF2)
			FF_SaveImage Img_HF2,0
			FF_SetControl "Runde Ecken","HF2",Img_HF2
			
			Farbe_HF3 = FF_GetControl("Farbdefinition","EHF3")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF3)
			FF_SaveImage Img_HF3,0
			FF_SetControl "Runde Ecken","HF3",Img_HF3

			Farbe_RF1 = FF_GetControl("Farbdefinition","ERF1")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF1)
			FF_SaveImage Img_RF1,0
			FF_SetControl "Runde Ecken","RF1",Img_RF1
			
			Farbe_RF2 = FF_GetControl("Farbdefinition","ERF2")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF2)
			FF_SaveImage Img_RF2,0
			FF_SetControl "Runde Ecken","RF2",Img_RF2
			
			Farbe_RF3 = FF_GetControl("Farbdefinition","ERF3")
			FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF3)
			FF_SaveImage Img_RF3,0
			FF_SetControl "Runde Ecken","RF3",Img_RF3

			FF_PopImage
			exit do
		Case "CANCEL","Abbrechen"
			exit do
		Case Else
	End Select
loop

FF_CloseDialog ("Farbdefinition")

End Sub
'------------------------------------------------------------------------
Function Farbreferenz (RGB_Wert)
'RGB-Wert ("000 000 000" bis "255 255 255") zu Farbreferenz (0 - 16777215)
Dim C_Array
	C_Array = split(RGB_Wert," ")
	Farbreferenz = C_Array(0) + C_Array(1) * (2^8) + C_Array(2) * (2^16)
End Function
'------------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'### Werte auslesen

eck_Radius = FF_GetProfile (RegSchluessel,"eck_Radius")
if eck_Radius = "" then eck_Radius = 100
eck_Radius = eck_Radius *1

h_Farbe = FF_GetProfile (RegSchluessel,"h_Farbe")
if h_Farbe = "" then h_Farbe = "000 000 000"

r_Staerke = FF_GetProfile (RegSchluessel,"r_Staerke")
if r_Staerke = "" then  r_Staerke = 5
r_Staerke = r_Staerke *1

r_Farbe = FF_GetProfile (RegSchluessel,"r_Farbe")
if r_Farbe = "" then r_Farbe = "255 000 000"

VkPmX = FF_GetProfile (RegSchluessel,"VkPmX")
if VkPmX = "" then  VkPmX = 0
VkPmX = VkPmX *1

vkPmY = FF_GetProfile (RegSchluessel,"vkPmY")
if vkPmY = "" then  vkPmY = 0
vkPmY = vkPmY *1

VsPmX = FF_GetProfile (RegSchluessel,"VsPmX")
if VsPmX = "" then  VsPmX = 0
VsPmX = VsPmX *1

VsPmY = FF_GetProfile (RegSchluessel,"VsPmY")
if VsPmY = "" then  VsPmY = 0
VsPmY = VsPmY *1

flag_Beschnitt = FF_GetProfile (RegSchluessel,"flag_Beschnitt")
if flag_Beschnitt = "" then flag_Beschnitt = 0

flag_Aktiv = FF_GetProfile (RegSchluessel,"flag_Aktiv")
if flag_Aktiv = "" then flag_Aktiv = 1

flag_ClipBoard = FF_GetProfile (RegSchluessel,"flag_ClipBoard")
if flag_ClipBoard = "" then flag_ClipBoard = 0

flag_PNG = FF_GetProfile (RegSchluessel,"flag_PNG")
if flag_PNG = "" then flag_PNG = 0

Farbe_HF1 = FF_GetProfile (RegSchluessel,"Farbe_HF1")
if Farbe_HF1 = "" then Farbe_HF1 = "245 245 245"

Farbe_HF2 = FF_GetProfile (RegSchluessel,"Farbe_HF2")
if Farbe_HF2 = "" then Farbe_HF2 = "255 000 000"

Farbe_HF3 = FF_GetProfile (RegSchluessel,"Farbe_HF3")
if Farbe_HF3 = "" then Farbe_HF3 = "000 000 255"

Farbe_RF1 = FF_GetProfile (RegSchluessel,"Farbe_RF1")
if Farbe_RF1 = "" then Farbe_RF1 = "000 255 000"

Farbe_RF2 = FF_GetProfile (RegSchluessel,"Farbe_RF2")
if Farbe_RF2 = "" then Farbe_RF2 = "255 000 000"

Farbe_RF3 = FF_GetProfile (RegSchluessel,"Farbe_RF3")
if Farbe_RF3 = "" then Farbe_RF3 = "000 000 255"

'### Werte eintragen

FF_SetControl "Runde Ecken","|",eck_Radius
FF_SetControl "Runde Ecken","h_Farbe",h_Farbe
FF_SetControl "Runde Ecken","||",r_Staerke
FF_SetControl "Runde Ecken","r_Farbe",r_Farbe
FF_SetControl "Runde Ecken","flag_Beschnitt",flag_Beschnitt
FF_SetControl "Runde Ecken","flag_Aktiv",flag_Aktiv
FF_SetControl "Runde Ecken","flag_ClipBoard",flag_ClipBoard
FF_SetControl "Runde Ecken","flag_PNG",flag_PNG

'vordefinierte Farbwerte
FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF1)
FF_SaveImage Img_HF1,0			
FF_SetControl "Runde Ecken","HF1",Img_HF1

FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF2)
FF_SaveImage Img_HF2,0			
FF_SetControl "Runde Ecken","HF2",Img_HF2

FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_HF3)
FF_SaveImage Img_HF3,0			
FF_SetControl "Runde Ecken","HF3",Img_HF3

FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF1)
FF_SaveImage Img_RF1,0			
FF_SetControl "Runde Ecken","RF1",Img_RF1

FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF2)
FF_SaveImage Img_RF2,0			
FF_SetControl "Runde Ecken","RF2",Img_RF2

FF_NewImage Bbutton,Hbutton,Farbreferenz(Farbe_RF3)
FF_SaveImage Img_RF3,0			
FF_SetControl "Runde Ecken","RF3",Img_RF3

End Sub
'------------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"eck_Radius",eck_Radius
FF_WriteProfile RegSchluessel,"h_Farbe",h_Farbe
FF_WriteProfile RegSchluessel,"r_Staerke",r_Staerke
FF_WriteProfile RegSchluessel,"r_Farbe",r_Farbe
FF_WriteProfile RegSchluessel,"VkPmX",VkPmX
FF_WriteProfile RegSchluessel,"vkPmY",vkPmY
FF_WriteProfile RegSchluessel,"VsPmX",VsPmX
FF_WriteProfile RegSchluessel,"VsPmY",VsPmY
FF_WriteProfile RegSchluessel,"flag_Beschnitt",flag_Beschnitt
FF_WriteProfile RegSchluessel,"flag_Aktiv",flag_Aktiv
FF_WriteProfile RegSchluessel,"flag_ClipBoard",flag_ClipBoard
FF_WriteProfile RegSchluessel,"flag_PNG",flag_PNG

FF_WriteProfile RegSchluessel,"Farbe_HF1",Farbe_HF1
FF_WriteProfile RegSchluessel,"Farbe_HF2",Farbe_HF2
FF_WriteProfile RegSchluessel,"Farbe_HF3",Farbe_HF3
FF_WriteProfile RegSchluessel,"Farbe_RF1",Farbe_RF1
FF_WriteProfile RegSchluessel,"Farbe_RF2",Farbe_RF2
FF_WriteProfile RegSchluessel,"Farbe_RF3",Farbe_RF3

End Sub
'------------------------------------------------------------------------
Sub WerteAuslesen

h_Farbe	= FF_GetControl ("Runde Ecken","h_Farbe")
hF_ref = Farbreferenz(h_Farbe)

r_Farbe	= FF_GetControl ("Runde Ecken","r_Farbe")
rF_ref = Farbreferenz(r_Farbe)

flag_Beschnitt = FF_GetControl ("Runde Ecken","flag_Beschnitt")
flag_Aktiv	= FF_GetControl ("Runde Ecken","flag_Aktiv")
flag_ClipBoard	= FF_GetControl ("Runde Ecken","flag_ClipBoard")
flag_PNG	= FF_GetControl ("Runde Ecken","flag_PNG")

End Sub
'------------------------------------------------------------------------
Function Version_OK(MinVersion)
dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### beigepackten Ordner lschen
TempFile = FF_GetScriptPath & "\MeckiScript\RundeEcken"
if objFS.FolderExists(TempFile) then objFS.DeleteFolder TempFile,true

'### ggf. Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Das Skript" & Skriptname & vbNewLine & "wurde mit allen Komponenten gelscht!" & vbNewLine & _
	   "Es wird empfohlen die 'Automatische Skriptkonfiguration' aufzurufen.",vbExclamation,"Hinweis"

End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'------------------------------------------------------------------------
Sub Vorschau

FF_SetControl "Runde Ecken","|||"	,(1000 - vkPmY)/10 & "%"
FF_SetControl "Runde Ecken","||||"	,(1000 - vkPmX)/10 & "%"
FF_SetControl "Runde Ecken","|||||"	,VsPmY * -1 & ""
FF_SetControl "Runde Ecken","||||||",VsPmX & ""

call WerteAuslesen

FF_PushImage
	show = true
	FF_HQScale 350,350,true
	call Ecken
	FF_SetControl "Runde Ecken","VS_Image",tempImage
	FF_PopImage
FF_PopImage

End Sub
'------------------------------------------------------------------------
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
